#include"MotorKlasse.h"
#include"SensorKlasse.h"
#include <SimpleList.h>
#include <Servo.h>

Motor rechterMotor;
Motor linkerMotor;

Sensor sensorVorneUntenRechts;
Sensor sensorVorneUntenLinks;
Sensor sensorHintenUnten;
Sensor sensorVorne;
Sensor sensorHinten;

Servo servo;   //Servo für den Sensor sensorVorne

int wait = 3;
int counter = 0;
int gradServo = 30;

SimpleList<char>* weg = new SimpleList<char>();
int theSize = weg->size();


void setup() {
  Serial.begin(9600);

  rechterMotor.setup(3, 4);
  linkerMotor.setup(5, 6);

  sensorVorneUntenRechts.setup(7, 8);
  sensorVorneUntenLinks.setup(A4, A5);
  sensorHintenUnten.setup(9, 10);
  sensorVorne.setup(A2, A3);
  sensorHinten.setup(11, 12);

  servo.attach(A1);
}


void loop() {
  int abstandVorneUntenRechts = sensorVorneUntenRechts.abstandMessen();
  int abstandVorneUntenLinks = sensorVorneUntenLinks.abstandMessen();
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  int abstandVorne = sensorVorne.abstandMessen();
  int abstandHinten = sensorHinten.abstandMessen();

  /*Serial.println(abstandVorneUntenRechts);
    Serial.println(abstandVorneUntenLinks);
    Serial.println(abstandHintenUnten);
    Serial.println(abstandVorne);
    Serial.println(abstandHinten);*/


  int grad = objektFinden();
  zuObjektDrehen(grad);
  fahreZuObjekt();
  vonObjektEntfernen();
  drivebwdl(150);
}


void drivefwd() {
  // Fahre vorwärts
  rechterMotor.drivefwd(wait);
  linkerMotor.drivefwd(wait);
  counter++;
  if (counter == 3) {
    rechterMotor.drivefwd(wait);
    rechterMotor.drivefwd(wait);
    counter = 0;
  }
  weg->add('f');
}


void drivebwd() {
  // Fahre rückwärts
  rechterMotor.drivebwd(wait);
  linkerMotor.drivebwd(wait);
  counter++;
  if (counter == 3) {
    rechterMotor.drivebwd(wait);
    rechterMotor.drivebwd(wait);
    counter = 0;
  }
  weg->add('b');
}


/*void drivefwdl() {
  //fahre nach vorne rechts
  rechterMotor.drivefwd(wait);
  linkerMotor.drivebwd(wait);
  rechterMotor.drivefwd(wait);
  }


  void drivefwdr() {
  //fahre nach vorne links
  rechterMotor.drivebwd(wait);
  linkerMotor.drivefwd(wait);
  }*/


void drivebwdl(int val) {
  //fahre nach hinten links
  for (int i = 0; i < val; i++) {
    rechterMotor.drivebwd(wait);
    linkerMotor.drivefwd(wait);
    rechterMotor.drivebwd(wait);

    weg->add('l');
  }
}


void drivebwdr(int val) {
  //fahre nach hinten rechts
  for (int i = 0; i < val; i++) {
    linkerMotor.drivebwd(wait);
    rechterMotor.drivefwd(wait);
    
    weg->add('r');
  }
}


int objektFinden() {
  int  abstandVorne = 200;
  int grad = 30;
  for (int i = 40; i <= 115; i++) {
    servo.write(i);
    int abstandVorneNeu = sensorVorne.abstandMessen();
    if ((abstandVorneNeu < abstandVorne) && (abstandVorneNeu > 10)) {
      abstandVorne = abstandVorneNeu;
      grad = i;
    }
    delay(100);
  }
  servo.write(grad);
  return grad;
}


void zuObjektDrehen(int grad) {
  if (grad > 72) {
    drivebwdl((grad - 72) * 2);
  } else {
    drivebwdr((72 - grad) * 2);
  }
  delay(2829);
}


void fahreZuObjekt() {
  int abstandVorne = sensorVorne.abstandMessen();
  int tod = abgrund();
  servo.write(72);
  do {
    abstandVorne = sensorVorne.abstandMessen();
    tod = abgrund();
    drivefwd();
  } while ((abstandVorne > 10) && (tod == 0));
  delay(3000);
}


void vonObjektEntfernen() {
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  int abstandHinten = sensorHinten.abstandMessen();
  for (int i = 0; i < 207; i++) {
    if ((abstandHintenUnten < 10) && (abstandHinten > 10)) {
      drivebwd();
      abstandHintenUnten = sensorHintenUnten.abstandMessen();
      abstandHinten = sensorHinten.abstandMessen();
    } else {
      break;
    }
  }
  delay(2500);
}


int abgrund() {
  int abstandVorneUntenLinks = sensorVorneUntenLinks.abstandMessen();
  int abstandVorneUntenRechts = sensorVorneUntenRechts.abstandMessen();
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  Serial.println(abstandVorneUntenLinks);
  Serial.println(abstandVorneUntenRechts);
  Serial.println(abstandHintenUnten);
  if ((abstandVorneUntenLinks < 10) && (abstandVorneUntenRechts < 10) && (abstandHintenUnten < 10)) {
    return 0; //kein abgrund
  } else {
    return 1; //abgrund ist da
  }
}
